
modLoader.define 'controllers/app', (require,exports) ->
  _3rdparty = modLoader.require('libs/3rdparty')
  ich     = _3rdparty.ich
  $       = _3rdparty.$

  Properties       = modLoader.require 'helpers/properties'
  RedditAdapter    = modLoader.require 'adapters/reddit'
  
  SubRedditModel   = modLoader.require 'models/sub_reddit'

  SubRedditPostsController   = modLoader.require 'controllers/subreddit_posts'
  NavController    = modLoader.require 'controllers/nav'

  class AppController
    constructor: (options)->
      @_reddit = options.reddit
      @_currentPage = null
      @_pages = {}
      @_navView = null
      return

    start: ->
      @_initAppView()

      @_initPages()

      # load the starting view
      @_loadLastView()
      return

    _initAppView: ->
      # add the nav bar
      @_navView = NavController.create({reddit: @_reddit, controller: @})
      @_navView.attachTo($('#navbar .subreddits'))
      return

    _initPages: ->
      _pages = @_pages
      _pages['subreddit-posts'] = SubRedditPostsController.create({reddit: @_reddit, controller: @})
      _pages['subreddit-posts'].attachTo($('#subreddit-posts'))
      return

    _loadLastView: ->
      # TODO switch view based on some setting
      if @_currentPage
        @_currentPage.hide()

      @_currentPage = @_pages['subreddit-posts']
      @_currentPage.show(SubRedditModel.create({url:'/',title:'Front Page'}))
      return

    storeSubReddits: (subs) ->
      @_subs = {}
      for sub in subs.data
        @_subs[sub.id()] = sub
      return

    showSubRedditPosts: (id)->
      sub = @_subs[id]
      @_currentPage.show(sub)
      return
      
    showPosts: ()->
      return

  exports.create = (options)->
    return new AppController options
  return