modLoader.define 'controllers/nav', (require, exports) ->
  ich = modLoader.require('libs/3rdparty').ich
  $   = modLoader.require('libs/3rdparty').$
  
  RedditAdapter    = modLoader.require 'adapters/reddit'

  SubRedditsWidget = modLoader.require 'widgets/subreddits'

  class NavController
    constructor: (options)->
      @_reddit = options.reddit
      @_controller = options.controller
      return

    attachTo: (container)->
      @_refs =
        container: container

      @_loadSubReddits(@_refs['container'])
      return

    _loadSubReddits: (container)->
      @_navScroll.destroy() if @_navScroll?
      @_navScroll = null;
      
      promise = null
      if @_reddit.isLoggedIn()
        promise = @_reddit.listUserSubReddits(RedditAdapter.PAGINATE_TYPE.AFTER, null, RedditAdapter.REDDITS_SORT_TYPES.POPULAR)
      else
        promise = @_reddit.listAllSubReddits(RedditAdapter.PAGINATE_TYPE.AFTER, null, RedditAdapter.REDDITS_SORT_TYPES.POPULAR)

      promise.done (subs) =>
        @_controller.storeSubReddits(subs)

        subReddits = SubRedditsWidget.create
          subReddits: subs
          controller: @_controller

        subReddits.appendTo(container)
        options =
          verticalScroll:   false         #vertical scrolling
          horizontalScroll: true          #horizontal scrolling
          scrollBars:       false          #display scrollbars

        @_navScroll = $('#subreddit-wrapper').scroller(options)
        return

      promise.fail (error)->
        container.append ich.error_inline {error: 'Failed to load subreddits :('}
      return

  exports.create = (options)->
    return new NavController(options)

  return