modLoader.define 'controllers/subreddit_posts', (require, exports) ->
  _3rdparty = modLoader.require('libs/3rdparty')
  ich     = _3rdparty.ich
  $       = _3rdparty.$
  
  RedditAdapter    = modLoader.require 'adapters/reddit'
  PostsWidget      = modLoader.require 'widgets/posts'

  class SubRedditPostsController
    constructor: (options, controller)->
      @_reddit = options.reddit
      @_controller = options.controller
      return

    attachTo: (container)->
      @_refs =
        container: container
        appHeader: $('#header .title h2')
        content: $('#subreddit-posts .posts')
      return

    show: (subReddit)->
      @_refs['appHeader'].text subReddit.title();

      @_loadPosts(@_refs['content'], subReddit)
      return

    hide: () ->
      return

    _loadPosts: (container, sub)->
      # Remove any existing children
      $('#subreddit-posts .posts > *').remove()

      promise = @_reddit.listSubRedditPost(RedditAdapter.PAGINATE_TYPE.AFTER, null, sub, RedditAdapter.POST_SORT_TYPES.HOT)
      promise.done (posts) =>
        postsWidget = PostsWidget.create(sub.title(), posts)
        postsWidget.appendTo(container)

        if !@_postScroller?
          options =
            verticalScroll:   true          #vertical scrolling
            horizontalScroll: false         #horizontal scrolling
            scrollBars:       false          #display scrollbars
          @_postScroller = $('#posts-wrapper').scroller(options)


        return

      promise.fail (error)->
        container.append ich.error_inline {error: 'Failed to load sub reddit\'s posts :('}
        return
      return

  exports.create = (options)->
    return new SubRedditPostsController(options)
  return